# Define templates
include:
  - project: "${GITLAB_CI_TEMPLATES_PATH}"
    file: "${GITLAB_CI_TEMPLATES_FILE}"
    ref: "master"

# Define stages
stages:
  - build
  - predeploy
  - deploy
  - test
  - publish
  - release
  - upgrade
  - clean

# Define global variables
variables:
  P_NAME: "gazelle-hl7v2-validator"
  P_APP_TYPE: "java"
  P_CODE_SRC_PATH: "."
  P_MAVEN_IMAGE_TAG: "3.6.3-jdk-8-slim"

# Define jobs
compile/unit-test:
  stage: build
  extends:
    - .buildJavaMavenTest
  variables:
    MAVEN_PHASE: "clean install"

package:
  stage: build
  extends:
    - .buildJavaMavenPackage
  needs:
    - job: compile/unit-test
      artifacts: true
  variables:
      P_MAVEN_EXTRA_ARGS: "-DskipTests"

static-analysis:
  stage: test
  extends:
    - .testJavaMavenSonarAnalysis

install-cache-repo:
  stage: publish
  extends:
    - .publishJavaMavenInstall
  needs:
    - job: package
      artifacts: false
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"

release/code:
  stage: release
  extends:
    - .releaseCodeForJava
  variables:
    P_MAVEN_JAVADOC_SKIP: "true"
    SCRIPTS_GIT_BRANCH: "master"
